package com.ccnode.codegenerator.mybatisGenerator.plugins.tools;

package .tmp;

import org.mybatis.generator.api.IntrospectedTable;
import org.mybatis.generator.api.dom.java.Field;
import org.mybatis.generator.api.dom.java.FullyQualifiedJavaType;
import org.mybatis.generator.api.dom.java.JavaVisibility;
import org.mybatis.generator.api.dom.java.Method;
import org.mybatis.generator.api.dom.java.Parameter;
import org.mybatis.generator.internal.util.messages.Messages;

public class JavaElementGeneratorTools {
  public static Field a(String paramString1, FullyQualifiedJavaType paramFullyQualifiedJavaType, String paramString2) {
    Field field = new Field(paramString1, paramFullyQualifiedJavaType);
    field.setVisibility(JavaVisibility.PUBLIC);
    field.setStatic(true);
    field.setFinal(true);
    if (paramString2 != null)
      field.setInitializationString(paramString2); 
    return field;
  }
  
  public static Field a(String paramString1, JavaVisibility paramJavaVisibility, FullyQualifiedJavaType paramFullyQualifiedJavaType, String paramString2) {
    Field field = new Field(paramString1, paramFullyQualifiedJavaType);
    field.setVisibility(paramJavaVisibility);
    if (paramString2 != null)
      field.setInitializationString(paramString2); 
    return field;
  }
  
  public static Method a(String paramString, JavaVisibility paramJavaVisibility, FullyQualifiedJavaType paramFullyQualifiedJavaType, Parameter... paramVarArgs) {
    Method method = new Method(paramString);
    method.setVisibility(paramJavaVisibility);
    method.setReturnType(paramFullyQualifiedJavaType);
    if (paramVarArgs != null)
      for (Parameter parameter : paramVarArgs)
        method.addParameter(parameter);  
    return method;
  }
  
  public static Method a(Method paramMethod, String... paramVarArgs) {
    if (paramVarArgs != null)
      for (String str : paramVarArgs)
        paramMethod.addBodyLine(str);  
    return paramMethod;
  }
  
  public static Method a(Field paramField) {
    Method method = a("set" + paramField
        .getName().substring(0, 1).toUpperCase() + paramField.getName().substring(1), JavaVisibility.PUBLIC, null, new Parameter[] { new Parameter(paramField

            
            .getType(), paramField.getName()) });
    return a(method, new String[] { "this." + paramField.getName() + " = " + paramField.getName() + ";" });
  }
  
  public static Method b(Field paramField) {
    Method method = a("get" + paramField
        .getName().substring(0, 1).toUpperCase() + paramField.getName().substring(1), JavaVisibility.PUBLIC, paramField
        
        .getType(), new Parameter[0]);
    return a(method, new String[] { "return this." + paramField.getName() + ";" });
  }
  
  public static FullyQualifiedJavaType a(IntrospectedTable paramIntrospectedTable) {
    FullyQualifiedJavaType fullyQualifiedJavaType;
    if (paramIntrospectedTable.getRules().generateBaseRecordClass()) {
      fullyQualifiedJavaType = new FullyQualifiedJavaType(paramIntrospectedTable.getBaseRecordType());
    } else if (paramIntrospectedTable.getRules().generatePrimaryKeyClass()) {
      fullyQualifiedJavaType = new FullyQualifiedJavaType(paramIntrospectedTable.getPrimaryKeyType());
    } else {
      throw new RuntimeException(Messages.getString("RuntimeError.12"));
    } 
    return fullyQualifiedJavaType;
  }
  
  public static FullyQualifiedJavaType b(IntrospectedTable paramIntrospectedTable) {
    FullyQualifiedJavaType fullyQualifiedJavaType;
    if (paramIntrospectedTable.getRules().generateRecordWithBLOBsClass()) {
      fullyQualifiedJavaType = new FullyQualifiedJavaType(paramIntrospectedTable.getRecordWithBLOBsType());
    } else {
      fullyQualifiedJavaType = new FullyQualifiedJavaType(paramIntrospectedTable.getBaseRecordType());
    } 
    return fullyQualifiedJavaType;
  }
}
